

#include <fstream.h>
#include <iostream.h>
#include <unistd.h>
#include "ECString.h"
#include "auxify.h"
#include "ECArgs.h"
#include "InputTree.h"
#include "headFinder.h"
#include "Term.h"
#include "BrownIter.h"

int
main(int argc, char *argv[])
{
   ECArgs args( argc, argv );
   assert(args.nargs() == 3);

   ECString  path( args.arg( 0 ) );
   ECString  brpath( args.arg(1));
   ECString  fl(args.arg(2));

   Term::init(path);
   readHeadInfo(path);

   ECString trnstg(brpath);
   trnstg += fl;
   trnstg += "/";
   trnstg += fl;
   trnstg += ".train";
   ofstream trnstrm(trnstg.c_str());
   assert(trnstrm);

   ECString tststg(brpath);
   tststg += fl;
   tststg += "/";
   tststg += fl;
   tststg += ".test";
   ofstream tststrm(tststg.c_str());
   assert(tststrm);

   ECString foo;

   BrownIter bi(fl);

   /*
   ECString badsg(path);
   path += "test.bad";
   ifstream bads(path.c_str());
   */

   int n = 0;
   for( ;  ; n++ )
     {
       if(!bi.next()) break;
       InputTree     correct(bi.dataStream());  
       //InputTree correct(bads);
       if(correct.finish() == 0)
	 {
	   n--;
	   continue;
	 }
       if(n < 2000) trnstrm << correct << endl;
       else tststrm << correct << endl;
       cerr << n << " " << correct << endl;
     }
}
