
#include <fstream.h>
#include <sys/resource.h>
#include <iostream.h>
#include <unistd.h>
#include <set.h>
#include "ECArgs.h"
#include "InputTree.h"
#include "Term.h"
#include "headFinder.h"

set<string, less<string> > wordSet;

int
main(int argc, char *argv[])
{
   struct rlimit 	core_limits;
   core_limits.rlim_cur = 0;
   core_limits.rlim_max = 0;
   setrlimit( RLIMIT_CORE, &core_limits );

   ECArgs args( argc, argv );
   cerr << "start listWords" << endl;

   ECString path = args.arg(0);
   Term::init( path );
   readHeadInfo(path);

   int sentenceCount = 0;
   for( ;  ; sentenceCount++)
     {
       //if(sentenceCount >= 2000) break;
       if(sentenceCount%10000 == 1)
	 {
	   cerr  << "lw "
	     << sentenceCount << endl;
	 }
       InputTree     correct;  
       cin >> correct;
       if(correct.length() == 0) break;
       EcSPairs wtList;
       correct.make(wtList); 
       EcSPairs::iterator li = wtList.begin();
       for( ; li != wtList.end() ; li++)
	 {
	   char tmp[128];
	   string& w = (*li).second;
	   string lw(toLower(w.c_str(),tmp));
	   wordSet.insert(lw);
	 }
     }
   set<string, less<string> >::iterator wsi = wordSet.begin();
   ECString resString(path);
   resString += "wordList.txt";
   ofstream res(resString.c_str());
   assert(res);
   for( ; wsi != wordSet.end() ; wsi++)
     res << (*wsi) << endl;
}

   
