
#include <iostream.h>
#include <stdiostream.h>
#include <fstream.h>

#include "ECArgs.h"
//ML #include <bstring.h>
#include "Term.h"
#include "utils.h"
#include "InputTree.h"
#include <map.h>
#include "headFinder.h"
#include "Pst.h" //???;

int posDenoms[100];
int posUCounts[100];
int posDashCounts[100];
int posCounts[100];
int posCapCounts[100];

void setNonTermInts();

/* read through wsj training data.
   compute p(x is head of NT | pos(x) =t) and put it in pTgNt.txt
   also compute ending info for pos's ie. p(ending(x) | pos(x)).
   goes at the end of the same file */

InputTree* curSent;

int                 data[60][30];
int numEndings = 0;

typedef map<ECString,int, less<ECString> > endMap;
endMap endData[40];
int                 numTerm[40];

void
incrEndData(int lhsInt, ECString e)
{
  endMap::iterator emi = endData[lhsInt].find(e);
  if(emi == endData[lhsInt].end())
    {
      endData[lhsInt][e] = 1;
      numEndings++;
    }
  else
    {
      (*emi).second++;
    }

}

void
addWwData(InputTree* tree)
{
  if( tree->word() != ""  )
    {
      ECString wTagNm = tree->term();
      const Term* trm = Term::get(wTagNm);
      int lhsInt = trm->toInt();
      ECString hdLexU(tree->word());
      char temp[128];
      ECString hdLex(toLower(hdLexU.c_str(),temp));
      int len = hdLex.length();
      const WordInfo* wi = Pst::get(hdLex); //???;
      //ML: I added this line for debugging     cerr << hdLex.c_str() << endl;
      assert(wi);
      /* Ignore words very close to start of sentence, those
	 that are of length 1, and those who's capitalization is
	 ambiguous. */
      if(tree->start() >= 2 && len > 1
	 &&!(hdLex[0] != hdLexU[0] && hdLex[1] != hdLexU[1]))
	{
	  posCounts[lhsInt]++;
	  if(hdLex[0] != hdLexU[0] && hdLex[1] == hdLexU[1])
	    {
	      posCapCounts[lhsInt]++;
	    }
	}
      posDenoms[lhsInt]++;
      if(wi->c() <= 2)
	{
	  posUCounts[lhsInt]++;
	  /*ML size_type*/ unsigned int pos =  hdLexU.find("-");
	  if( pos < len && pos >= 0) posDashCounts[lhsInt]++;
	}
      return;
    }
  InputTrees& st = tree->subTrees();
  InputTrees::iterator  subTreeIter= st.begin();
  InputTree  *subTree;
  for( ; subTreeIter != st.end() ; subTreeIter++ )
    {
      subTree = *subTreeIter;
      addWwData(subTree);
    }
}

int
main(int argc, char *argv[])
{
  ECArgs args( argc, argv );
  assert(args.nargs() == 1);
  ECString path(args.arg(0));
  cerr << "At start of pTgNt" << endl;

  for(int n = 0 ; n < 40 ; n++)
    numTerm[n] = 0;
	
  ECString trainingString(path);
  trainingString += "train.txt";
  ifstream    trainingStream(trainingString.c_str());
  assert(trainingStream);

  ECString resultsString(path);
  resultsString += "pUgT.new";

  Term::init( path );  
  readHeadInfo(path);
  Pst pst(path);

  int sentenceCount = 0;
  int wordCount = 0;
  int processedCount = 0;

  int i, j;
  for(i = 0 ; i < 50 ; i++)
    {
      posCounts[i] = 0;
      posCapCounts[i] = 0;
      posDenoms[i] = 0;
      posUCounts[i] = 0;
      posDashCounts[i] = 0;
    }

  i = 0;
  while(trainingStream)
    {
      if(i++%5000 == 1) cerr << i << endl;
      //if(i > 1000) break;
      InputTree  parse;
      trainingStream >> parse;
      if(!trainingStream) break;
      curSent = &parse;
      addWwData(&parse);
      processedCount++;
      wordCount += parse.length();
    }
  ofstream     resultsStream(resultsString.c_str());
  assert(resultsStream);
  /* we print out p(unknown|tag)    p(Capital|tag)   p(hasDash|tag, unknown)
     note for Capital the denom is different because we ignore the first
     two words of the sentence */
  for(i = 0 ; i < 47 ; i++)
    {
      resultsStream << i << "\t";




      // ML 6/21/03 NaN fix
      //resultsStream << (float)posUCounts[i]/(float)posDenoms[i] << "\t";
      float pugt = 0;
      float pudenom = (float)posDenoms[i];
      if(pudenom > 0) pugt = (float)posUCounts[i]/pudenom;
      resultsStream << pugt << "\t";




      if(posCounts[i] == 0) resultsStream << 0 << "\t";
      else
	resultsStream << (float) posCapCounts[i]/ (float)posCounts[i] << "\t";
      if(posUCounts[i] == 0) resultsStream << 0;
      else resultsStream << (float)posDashCounts[i]/posUCounts[i] ;
      resultsStream << endl;
    }
  return 0;
}
